#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<alloc.h>
//#include	<dos.h>

#include	<conio.h>
#include 	<i86.h>
#include	<malloc.h>

#define	COUNT5		2457600L	/* timer clock freq.[Hz] at 5/10/20MHz */
#define	COUNT8		1996800L	/* timer clock freq.[Hz] at 8/16MHz */
//#define	BIOS_FLAG	*(unsigned char far *)0x00000501L	/* BIOS_FLAG at system area */

unsigned char far	*BeepBuf;		/* data buffer pointer */
static int			playflag;
static long			playcount;
static long			playsize;
static unsigned int	count;

#define outportb	outp
#define inportb	inp
#define disable	_disable
#define enable	_enable
//#define getvect	_dos_getvect
//#define setvect	_dos_setvect
#define farmalloc	_fmalloc
#define farfree	_ffree

static void interrupt NewTimerVectBeep(void)
{
	static unsigned int	d;

	if(playcount < playsize){
		d=(unsigned int)(((unsigned int)BeepBuf[playcount++]*count)>>8)+1;
		outportb(0x3fdb, (unsigned char)(d&0x00ff));
		outportb(0x3fdb, (unsigned char)(d>>8));		/* counter start */
	}
	else
		playflag = 0;

	outportb(0x00,0x20);
}

long LoadBF(char *wavename)
{
	FILE *fp;
	long fsize=0;
	int read;

	if((fp = fopen(wavename, "rb")) == NULL) {
		fprintf(stderr, "Error! file open failed.\n");
		return -1L;
	}

	while((read=fgetc(fp))!=EOF){
		BeepBuf[fsize]=(char)read;
		fsize++;
	}

	fclose(fp);
	return(fsize);
}

void PlayWave(long Fsize,long khz)
{
//	void interrupt (*OrgTimerVect)(...);
	void interrupt (*OrgTimerVect)();
	unsigned char imr_m, imr_s;
	char	BIOS_FLAG;

	disable();								/* cli */
	outportb(0x02,inportb(0x02)|0x01);		/* set timer mask bit */
	enable();								/* sti */

	BIOS_FLAG = (inport (0x42) & 0x20)?0x80:0;
	BIOS_FLAG = (inport (0x42) == 0xff)?0:BIOS_FLAG;

	if(BIOS_FLAG & 0x80){				/* 8MHz/16MHz... */
		count=(unsigned int)((long)COUNT8/khz);
	}
	else{									/* 5MHz/10MHz... */
		count=(unsigned int)((long)COUNT5/khz);
	}


	/*0()̐ݒ*/
	outportb(0x77,0x36);				/* counter mode 3 */
	outportb(0x71,(unsigned char)(count&0x00ff));		/* rate LSB */
	outportb(0x71,(unsigned char)(count>>8));			/* rate MSB */

	playflag = 1;
	playcount = 0;
	playsize = Fsize;

//	OrgTimerVect = getvect(0x08);

//	setvect(0x08,(void interrupt (*)(...))NewTimerVectBeep);
//	setvect(0x08,(void interrupt (*)())NewTimerVectBeep);

	/*1(߰)̐ݒ*/
	outportb(0x77,0x70);					/* set timer #1 to mode 0 */
	outportb(0x35,(inportb(0x35)&(0xff-0x08)));	/* beep on */

	disable();								/* cli */
	outportb(0x02,inportb(0x02)&(~0x01));	/* clear timer mask bit */
	outportb(0x02,(imr_m=(unsigned char)inportb(0x02))|(0x00));
	outportb(0x0a,(imr_s=(unsigned char)inportb(0x0a))|(0x20));
	enable();								/* sti */

	while(playflag){};

	disable();								/* cli */
	outportb(0x02,imr_m);
	outportb(0x0a,imr_s);
	outportb(0x02,inportb(0x02)|0x01);		/* set timer mask bit */
	enable();								/* sti */

//	setvect(0x08,OrgTimerVect);

	/*1(ް)̐ݒ*/
	outportb(0x35,(inportb(0x35)|0x08));	/* beep off */
	outportb(0x77,0x76);					/* set timer #1 to mode 3 */
	if(BIOS_FLAG & 0x80){
		count=(unsigned int)((long)COUNT8/2000);
	}
	else{
		count=(unsigned int)((long)COUNT5/2000);
	}
	/*1(ް)̶Ēl*/
	outportb(0x3fdb,(unsigned char)(count&0x00ff));
	outportb(0x3fdb,(unsigned char)(count>>8));		/* set freq 2,000Hz */


	disable();								/* cli */
//	outportb(0x02,inportb(0x02)&(~0x01));	/* clear timer mask bit */
	outportb(0x02,inportb(0x02)|(01));	/* re-set timer mask bit */
	enable();								/* sti */
}


/*
 *	main function
 *****************************************************************************/
void main()
{
	char wavename[80];
	long fsize,freq;
//	unsigned char *BeepBuf;

	freq = 22050;
	strcpy(wavename,"weskar.spk");

//	BeepBuf=(unsigned char far *)farmalloc(65536);
	BeepBuf=(unsigned char far *)farmalloc(54000);
	if(BeepBuf == NULL) exit(1);
printf("far malloc at %x:%x\n",FP_SEG(BeepBuf),BeepBuf);

	printf("Loading wave ... ");

	if((fsize=LoadBF(wavename)) < 0L) {
		exit(1);
	}

	printf("OK(%ldbytes).\n",fsize);
	printf("Playing wave ... ");

	PlayWave(fsize,freq);

	printf("END.\n");
	farfree(BeepBuf);
}
